package com.sun.jndi.dns;

import javax.naming.NamingException;
import javax.naming.Name;
import java.util.NoSuchElementException;
import javax.naming.CompositeName;
import java.util.Hashtable;
import javax.naming.NamingEnumeration;
import javax.naming.NameClassPair;

final class NameClassPairEnumeration extends BaseNameClassPairEnumeration<NameClassPair> implements NamingEnumeration<NameClassPair>
{
    NameClassPairEnumeration(DnsContext dnsContext, Hashtable<String, NameNode> hashtable) {
        super(dnsContext, hashtable);
    }
    
    @Override
    public NameClassPair next() throws NamingException {
        if (!this.hasMore()) {
            throw new NoSuchElementException();
        }
        NameNode nameNode = (NameNode)this.nodes.nextElement();
        String className = (nameNode.isZoneCut() || nameNode.getChildren() != null) ? "javax.naming.directory.DirContext" : "java.lang.Object";
        Name add = new CompositeName().add(new DnsName().add(nameNode.getLabel()).toString());
        NameClassPair nameClassPair = new NameClassPair(add.toString(), className);
        nameClassPair.setNameInNamespace(this.ctx.fullyQualify(add).toString());
        return nameClassPair;
    }
}
